
Procedure PavInit;
Var i, j : Byte;
    p : PPavDef;
    Var s : String;
Begin
 For i := 1 To PavMax Do
  Begin
   p := TPav[i];
   If p<>NIL Then
    Begin
     s := '00/00';
     For j := 1 To p^.PCfg.MinMax Do
      Begin
       { libere toutes les voies associs... }

       p^.Com.PutTrame(j-1+CVBase,A_LIB,s);
       With p^.TMin[j]^ Do
        Begin
         OnLine := FALSE;
         oPos := 0;
         nc := -1;
         Id := 9999;
        End;
       SysInit(p^.TMin[j]^.Sys);
      End;
    End;
  End;
End;

Procedure PavDone;
Var i, j : Byte;
    s : String;
    t : Longint;
    p : PPavDef;
    Wait : Boolean;
Begin
 For i := 1 To PavMax Do
  Begin
   p := TPav[i];
   If p<>NIL Then
    Begin
     s := '00/00';
     For j := 1 To p^.PCfg.MinMax Do
      Begin
       { libere toutes les voies associs... }

       p^.Com.PutTrame(j-1+CVBase,A_LIB,s);
       With p^.TMin[j]^ Do
        Begin
         OnLine := FALSE;
         oPos := 0;
         nc := -1;
         Id := 9999;
        End;

       SysDeco(p^.TMin[j]^.Sys,0,0);
      End;
    End;
  End;

 t := GetC18+5*18;

 Repeat
  Wait := FALSE;
  For i := 1 To PavMax Do
   Begin
    p := TPav[i];
    If (p<>NIL) And (p^.Com.TransmitCount>0) Then
     Begin
      Wait := TRUE;
      Break;
     End;
   End;
 Until Not(Wait) Or (t<=GetC18);
End;


Function ExtractAppelInfo( Var p; Len : Integer; Var Id : Word ) : Integer;
Var don : Array[0..10000] Of Byte Absolute p;
    i : Integer;
    nc : Integer;
    nce : Boolean;
Begin
 Id := 9999;            { par dfaut... }
 ExtractAppelInfo := -1;       { idem... }

 If (Len>=1) And (don[0]=Byte('6')) Then
  Begin
   { appel videotex !!! }

   If (len>=9) Then
    Begin { Extraire """id""" }
     Id := 0;
     For i := 5 to 8 do Id := Id*10+(don[i]-Byte('0'));
    End;

   For i := 2 To Len Do
    Begin
     If (don[i-1]=Byte('/')) Then
      Begin { Extraire "NC"... }
       Inc(i);
       nce := FALSE;
       nc := 0;
       While( (i<=len) And (don[i-1]<>Byte('/')) ) Do
        Begin
         nce := TRUE;
         nc := nc*10+(don[i-1]-Byte('0'));
         Inc(i);
        End;

       If (nce) Then ExtractAppelInfo := nc;
       Break;
      End;
    End;
  End;
End;


Const PAV_RESET : String[11] = #27#27#27'!RSTTERM';   { Ordre d'init terminal }
      PAV_PIPE  : String[11] = #27#27#27'!PIPE:ON';   { force le mode "PIPE" }

Procedure PavRaz( Var m : PavMinDef );
Begin
 PaqFlush(m.Sys.PaqIn);
 PaqFlush(m.Sys.PaqOut);
 PaqSendExpress(m.Sys.PaqOut,PAV_PIPE[1],length(PAV_PIPE));
 PaqSendExpress(m.Sys.PaqOut,PAV_RESET[1],length(PAV_RESET));
End;


Function FastConnect( Var m : PavMinDef ) : Boolean;
Var x : Integer;
    zs : PMinSys;
    zid : Word;
Begin
 x := (m.nc mod 100);
 If ( (x>=1) And (x<=NamMax) And SysMaster(x,zs,zid) ) Then
  Begin
   If (zs=NIL) Then
    Begin
     If (zid=9999) Then
      Begin
       { devient maitre... }
       PavRaz(m);
       SysConnect(m.Sys,Byte(x));
       m.oPos := 3;
       m.FastConnect := TRUE;
       m.Sys.IsMaster := TRUE;
       m.Sys.CurrentNam^.Passe := '';
       FastConnect := TRUE;
       Exit;
      End;
    End
  End;
 m.FastConnect := FALSE;
 FastConnect := FALSE;
End;


{ Trait la reception d'une trame... }

Procedure Pav_NewTrame( Var Pav : PavDef );
Var np : Byte;
    m : PPavMinDef;
    n : PNamDef;
Begin
 np := Byte(Pav.Com.C_NT-CVBase);
 If (Pav.Com.C_TM=A_RESO) Then
  Begin
   { trame de rso recu!!! }
   { on renvoi sur le "bon" NAM... }
   { np=nlogique du port... }
   If (np>=RLOG_BASE) And (np<(RLOG_BASE+NamMax)) Then
    Begin
     n := TNam[np-RLOG_BASE+1];
     if (n<>NIL) Then
      Begin
       { renvoi vers le "bon" NAM ... }
       _SendTrame(n^,np,A_RESO,Pav.Com.C_Don,Pav.Com.C_LgDon);
      End;
    End;
  End
 Else
 If (np<Pav.PCfg.MinMax) Then
  Begin
   m := Pav.TMin[np+1];
   If m<>NIL Then
    Begin
     Case Pav.Com.C_TM Of
      A_COMM : ;                { ignore... }
      A_LIB  :
       Begin
        SysDeco(m^.Sys,0,0);
        m^.OnLine := FALSE;
       End;
      A_APPEL :
       Begin
        m^.OnLine := TRUE;
        m^.oPos := 0;
        m^.nc := ExtractAppelInfo(Pav.Com.C_Don,Pav.Com.C_LgDon,m^.Id);
        m^.FastConnect := FALSE;     { par dfaut... }
        SysDeco(m^.Sys,0,0);    { pour la forme... }

        FastConnect(m^);
       End;
      A_DON :
       If m^.OnLine Then
        If (Pav.Com.C_LgDon>=3) And (Pav.Com.C_Don[0]=27) And
           (Pav.Com.C_Don[1]=27) And (Pav.Com.C_Don[2]=27) Then
         Begin
          { rien a faire!!! a la poubelle !!! }
         End
        Else PaqSendExpress(m^.Sys.PaqIn,Pav.Com.C_Don,Pav.Com.C_LgDon);
     End;
    End;
  End;
End;


Function LockKoi( Var Sai : String; Var nNam : LongInt; Var Passe : String ) : Boolean;
Var n : Word;
    i : Word;
    len : Integer;
Begin
 len := Length(Sai);
 If (len>=1) And (UpCase(Sai[1])='L') Then
  Begin
   n := 0;
   For i := 2 To len Do
    Begin
     If (Sai[i]=' ') Then Break;
     n := n*10+(Byte(Sai[i])-Byte('0'));
    End;

   Inc(i);

   nNam := n;

   While (i<=len) And (Sai[i]=' ') Do Inc(i);

   { Note le passe... }
   Passe := '';

   While (i<=len) And (Length(Passe)<8) Do
    Begin
     Passe[length(Passe)+1] := UpCase(Sai[i]);
     Inc(Passe[0]);
     Inc(i);
    End;

   LockKoi := TRUE;
   Exit;
  End;
 LockKoi := FALSE;
End;


Procedure PavReview;
Const ComOff : String[35] = #$14#$14+POSLZ+'fin de communication'#$0A;
      ClrIn : String[10] = #$1F#$51#$55'..'#$1F#$51#$55#$11;
      PosId : String[3] = #$1F#$55#$64;
Var i, j : Byte;
    p : PPavDef;
    m : PPavMinDef;
    Dest : String;
    Tp : Byte;
    tche : Char;
    x : LongInt;
    Err : Word;
    zs : PMinSys;
    zid : Word;
    passe : String[20];
Begin
 For i := 1 To PavMax Do
  Begin
   p := TPav[i];
   If p<>NIL Then
    Begin
     If p^.Com.Saisie Then Pav_NewTrame(p^);
     For j := 1 To p^.PCfg.MinMax Do
      Begin
       m := p^.TMin[j];
       If (m^.OnLine) And Not(m^.Sys.cvon) Then
        Begin
         { traitement special... }
         Case m^.oPos Of
          0 :
           Begin
            If m^.FastConnect Then
             Begin     { deconnexion de NAMSIM ! }
              SysDeco(m^.Sys,0,0);
              Dest := '00/00';
              p^.Com.PutTrame(j-1+CVBase,A_LIB,Dest);
              m^.OnLine := FALSE;
             End
            Else
             Begin
              PavRaz(m^);
              SendFile(m^.Sys,FileSeek('NAMPAV.VDT'));
              Inc(m^.oPos);
             End;
           End;
          1 :
           Begin
            PaqSendData(m^.Sys.PaqOut,ClrIn[1],Length(ClrIn));
            Inc(m^.oPos);
           End;
          2 :
           Begin
            If PaqPop(m^.Sys.PaqIn,Tp,Dest) Then
             If DetectFin(Dest) Then
              Begin
              End
             Else
              Begin
               m^.oPos := 1;       { par defaut }
               If (Length(Dest)>=2) And (Dest[length(Dest)]=#13) Then
                Begin
                 tche := Dest[length(Dest)-1];
                 dec(Dest[0],2);
                End
               Else tche := #0;
               Case tche Of
                T_REPETITION : m^.oPos := 0;
                T_SOMMAIRE :
                 Begin     { deconnexion de NAMSIM ! }
                  SysDeco(m^.Sys,0,0);
                  Dest := '00/00';
                  p^.Com.PutTrame(j-1+CVBase,A_LIB,Dest);
                  m^.OnLine := FALSE;
                 End;
                T_ENVOI :
                 Begin
                  If LockKoi(Dest,x,passe) Then
                   Begin
                    If (x>=1) And (x<=NamMax) And SysMaster(x,zs,zid) Then
                     Begin
                      If zs=NIL Then
                       If (zid=9999) Then
                        Begin { devient le maitre!!! }
                         SysConnect(m^.Sys,Byte(x));
                         m^.oPos := 3;
                         m^.Sys.IsMaster := TRUE;
                         m^.Sys.CurrentNam^.Passe := Passe;
                        End
                       Else
                        Begin { y a un occupant (non maitre) }
                         SendFile(m^.Sys,FileSeek('NAMPAVI.VDT'));
                         PaqSendData(m^.Sys.PaqOut,PosId[1],Length(PosId));
                         Dest := Val2Str(zid,4);
                         PaqSendData(m^.Sys.PaqOut,Dest[1],Length(Dest));
                        End
                      Else { y a un matre }
                       If (zs^.CurrentNam^.Passe<>'') And
                          (zs^.CurrentNam^.Passe=Passe) Then
                        Begin { le passe est bon !!! }
                         SysConnect(m^.Sys,Byte(x));
                         m^.oPos := 3;
                        End
                       Else
                        Begin { accs ferm!!! }
                         SendFile(m^.Sys,FileSeek('NAMPAVL.VDT'));
                         PaqSendData(m^.Sys.PaqOut,PosId[1],Length(PosId));
                         Dest := Val2Str(zid,4);
                         PaqSendData(m^.Sys.PaqOut,Dest[1],Length(Dest));
                        End;
                     End
                    Else SendFile(m^.Sys,FileSeek('NAMPAVE.VDT'));
                   End
                  Else
                   Begin
                    Val(Dest,x,Err);
                    If (Err=0) And (x>=1) And (x<=NamMax) And
                       (SysMaster(x,zs,zid)) THen
                     Begin
                      If (zs=NIL) Then
                       Begin
                        SysConnect(m^.Sys,Byte(x));
                        m^.oPos := 3;
                       End
                      Else
                       Begin { il y a un matre!!! }
                        SendFile(m^.Sys,FileSeek('NAMPAVL.VDT'));
                        PaqSendData(m^.Sys.PaqOut,PosId[1],Length(PosId));
                        Dest := Val2Str(zid,4);
                        PaqSendData(m^.Sys.PaqOut,Dest[1],Length(Dest));
                       End;
                     End
                    Else SendFile(m^.Sys,FileSeek('NAMPAVE.VDT'));
                   End;
                 End;
                End;
              End;
           End;
          3 :
           Begin
            Dest := ComOff;
            PaqSendData(m^.Sys.PaqOut,Dest[1],Length(Dest));
            m^.oPos := 0;
           End;
          Else m^.oPos := 0;
         End;
        End;
      End;
    End;
  End;
End;


Procedure PavVide;
Var i, j : Byte;
    p : PPavDef;
    m : PPavMinDef;
    dt : String;
    Tp : Byte;
Begin
 For i := 1 To PavMax Do
  Begin
   p := TPav[i];
   If p<>NIL Then
    Begin
     For j := 1 To p^.PCfg.MinMax Do
      Begin
       m := p^.TMin[j];
       If PaqPop(m^.Sys.PaqOut,Tp,dt) Then
        Begin
         Case Tp Of
          DATA_RESET :
           Begin
            dt := PAV_RESET;   { Ordre d'init terminal }
            p^.Com.PutTrame(j-1+CVBase,A_DON,dt);
           End;
         Else p^.Com.PutTrame(j-1+CVBase,A_DON,dt);
         End;
        End;
      End;
    End;
  End;
End;


Procedure PavPolling;
Begin
 PavReview;
 PavVide;
End;


